Index: django/conf/locale/nl/LC_MESSAGES/django.po
===================================================================
--- django/conf/locale/nl/LC_MESSAGES/django.po	(revision 8070)
+++ django/conf/locale/nl/LC_MESSAGES/django.po	(working copy)
@@ -255,19 +255,19 @@
 
 #: contrib/admin/models.py:18
 msgid "action time"
-msgstr "actie tijd"
+msgstr "actietijd"
 
 #: contrib/admin/models.py:21
 msgid "object id"
-msgstr "object id"
+msgstr "object-id"
 
 #: contrib/admin/models.py:22
 msgid "object repr"
-msgstr "object repr"
+msgstr "object-repr"
 
 #: contrib/admin/models.py:23
 msgid "action flag"
-msgstr "actie vlag"
+msgstr "actievlag"
 
 #: contrib/admin/models.py:24
 msgid "change message"
@@ -275,11 +275,11 @@
 
 #: contrib/admin/models.py:27
 msgid "log entry"
-msgstr "log ingave"
+msgstr "logingave"
 
 #: contrib/admin/models.py:28
 msgid "log entries"
-msgstr "log ingaves"
+msgstr "logingaves"
 
 #: contrib/admin/templates/admin/404.html:4
 #: contrib/admin/templates/admin/404.html:8
@@ -309,15 +309,15 @@
 
 #: contrib/admin/templates/admin/500.html:4
 msgid "Server error"
-msgstr "Server fout"
+msgstr "Serverfout"
 
 #: contrib/admin/templates/admin/500.html:6
 msgid "Server error (500)"
-msgstr "Server fout (500)"
+msgstr "Serverfout (500)"
 
 #: contrib/admin/templates/admin/500.html:9
 msgid "Server Error <em>(500)</em>"
-msgstr "Server Fout <em>(500)</em>"
+msgstr "Serverfout <em>(500)</em>"
 
 #: contrib/admin/templates/admin/500.html:10
 msgid "There's been an error. It's been reported to the site administrators via e-mail and should be fixed shortly. Thanks for your patience."
@@ -345,11 +345,11 @@
 
 #: contrib/admin/templates/admin/base_site.html:4
 msgid "Django site admin"
-msgstr "Django site beheer"
+msgstr "Django sitebeheer"
 
 #: contrib/admin/templates/admin/base_site.html:7
 msgid "Django administration"
-msgstr "Django beheer"
+msgstr "Djangobeheer"
 
 #: contrib/admin/templates/admin/change_form.html:14
 #: contrib/admin/templates/admin/index.html:28
@@ -582,7 +582,7 @@
 
 #: contrib/admin/templates/admin_doc/bookmarklets.html:21
 msgid "Show object ID"
-msgstr "Toon object ID"
+msgstr "Toon object-ID"
 
 #: contrib/admin/templates/admin_doc/bookmarklets.html:22
 msgid "Shows the content-type and unique ID for pages that represent a single object."
@@ -617,7 +617,7 @@
 #: contrib/admin/templates/registration/password_change_form.html:5
 #: contrib/admin/templates/registration/password_change_form.html:9
 msgid "Password change"
-msgstr "Wachtwoord wijziging"
+msgstr "Wachtwoordwijziging"
 
 #: contrib/admin/templates/registration/password_change_done.html:5
 #: contrib/admin/templates/registration/password_change_done.html:9
@@ -795,12 +795,12 @@
 #: contrib/admin/views/doc.py:166
 #, python-format
 msgid "App %r not found"
-msgstr "App %r niet gevonden"
+msgstr "Toepassing %r niet gevonden"
 
 #: contrib/admin/views/doc.py:173
 #, python-format
 msgid "Model %(name)r not found in app %(label)r"
-msgstr "Model %(name)r niet gevonden in app %(label)r"
+msgstr "Model %(name)r niet gevonden in toepassing %(label)r"
 
 #: contrib/admin/views/doc.py:185
 #, python-format
@@ -886,7 +886,7 @@
 #: contrib/admin/views/doc.py:307
 #: contrib/comments/models.py:89
 msgid "IP address"
-msgstr "IP adres"
+msgstr "IP-adres"
 
 #: contrib/admin/views/doc.py:309
 msgid "Boolean (Either True, False or None)"
@@ -894,7 +894,7 @@
 
 #: contrib/admin/views/doc.py:310
 msgid "Relation to parent model"
-msgstr "Relatie tot ouder model"
+msgstr "Relatie tot oudermodel"
 
 #: contrib/admin/views/doc.py:311
 msgid "Phone number"
@@ -919,16 +919,16 @@
 
 #: contrib/admin/views/doc.py:320
 msgid "XML text"
-msgstr "XML Tekst"
+msgstr "XML-tekst"
 
 #: contrib/admin/views/doc.py:346
 #, python-format
 msgid "%s does not appear to be a urlpattern object"
-msgstr "%s lijkt geen urlpattern object te zijn"
+msgstr "%s lijkt geen urlpattern-object te zijn"
 
 #: contrib/admin/views/main.py:233
 msgid "Site administration"
-msgstr "Site beheer"
+msgstr "Sitebeheer"
 
 #: contrib/admin/views/main.py:280
 #: contrib/admin/views/main.py:365
@@ -957,7 +957,7 @@
 #: contrib/admin/views/main.py:346
 #, python-format
 msgid "Changed %s."
-msgstr "Gewijzigd %s"
+msgstr "%s gewijzigd."
 
 #: contrib/admin/views/main.py:348
 #, python-format
@@ -1019,7 +1019,7 @@
 
 #: contrib/admin/views/main.py:784
 msgid "Database error"
-msgstr "Database fout"
+msgstr "Databasefout"
 
 #: contrib/auth/forms.py:17
 #: contrib/auth/forms.py:138
@@ -1112,11 +1112,11 @@
 
 #: contrib/auth/models.py:136
 msgid "staff status"
-msgstr "staf status"
+msgstr "stafstatus"
 
 #: contrib/auth/models.py:136
 msgid "Designates whether the user can log into this admin site."
-msgstr "Bepaalt of de gebruiker kan inloggen op deze admin site."
+msgstr "Bepaalt of de gebruiker zich kan aanmelden op deze admin site."
 
 #: contrib/auth/models.py:137
 msgid "active"
@@ -1124,11 +1124,11 @@
 
 #: contrib/auth/models.py:137
 msgid "Designates whether this user can log into the Django admin. Unselect this instead of deleting accounts."
-msgstr "Bepaalt of de gebruiker kan inloggen op deze admin site. U kunt dit uitvinken in plaats van een gebruiker te verwijderen."
+msgstr "Bepaalt of de gebruiker zich kan aanmelden op deze admin site. U kunt dit uitvinken in plaats van een gebruiker te verwijderen."
 
 #: contrib/auth/models.py:138
 msgid "superuser status"
-msgstr "supergebruiker status"
+msgstr "supergebruikerstatus"
 
 #: contrib/auth/models.py:138
 msgid "Designates that this user has all permissions without explicitly assigning them."
@@ -1185,7 +1185,7 @@
 #: contrib/comments/models.py:71
 #: contrib/comments/models.py:176
 msgid "object ID"
-msgstr "object ID"
+msgstr "object-ID"
 
 #: contrib/comments/models.py:72
 msgid "headline"
@@ -1249,7 +1249,7 @@
 
 #: contrib/comments/models.py:90
 msgid "Check this box if the comment is inappropriate. A \"This comment has been removed\" message will be displayed instead."
-msgstr "Kruis deze box aan indien de opmerking niet gepast is. Een \"Dit commentaar is verwijderd\" bericht wordt dan getoond"
+msgstr "Kruis dit vak aan indien de opmerking niet gepast is. Een \"Dit commentaar is verwijderd\" bericht wordt dan getoond"
 
 #: contrib/comments/models.py:96
 msgid "comments"
@@ -1258,7 +1258,7 @@
 #: contrib/comments/models.py:140
 #: contrib/comments/models.py:222
 msgid "Content object"
-msgstr "Inhoud object"
+msgstr "Inhoud-object"
 
 #: contrib/comments/models.py:168
 #, python-format
@@ -1269,7 +1269,7 @@
 "\n"
 "http://%(domain)s%(url)s"
 msgstr ""
-"Gepost door %(user)s op %(date)s\n"
+"Geplaatst door %(user)s op %(date)s\n"
 "\n"
 "%(comment)s\n"
 "\n"
@@ -1281,7 +1281,7 @@
 
 #: contrib/comments/models.py:181
 msgid "ip address"
-msgstr "ip adres"
+msgstr "ip-adres"
 
 #: contrib/comments/models.py:183
 msgid "approved by staff"
@@ -1301,15 +1301,15 @@
 
 #: contrib/comments/models.py:251
 msgid "score date"
-msgstr "score datum"
+msgstr "scoredatum"
 
 #: contrib/comments/models.py:255
 msgid "karma score"
-msgstr "karma score"
+msgstr "karmascore"
 
 #: contrib/comments/models.py:256
 msgid "karma scores"
-msgstr "karma scores"
+msgstr "karmascores"
 
 #: contrib/comments/models.py:260
 #, python-format
@@ -1346,7 +1346,7 @@
 
 #: contrib/comments/models.py:300
 msgid "deletion date"
-msgstr "datum verwijdering"
+msgstr "verwijderingsdatum"
 
 #: contrib/comments/models.py:303
 msgid "moderator deletion"
@@ -1399,7 +1399,7 @@
 
 #: contrib/comments/views/comments.py:28
 msgid "This rating is required because you've entered at least one other rating."
-msgstr "Deze waardering is verplicht omdat u tenminste Ã©Ã©n andere waardering hebt ingevoerd."
+msgstr "Deze waardering is verplicht omdat u tenminste één andere waardering hebt ingevoerd."
 
 #: contrib/comments/views/comments.py:112
 #, python-format
@@ -1427,7 +1427,7 @@
 "\n"
 "%(text)s"
 msgstr ""
-"Deze opmerking is gepost door een \"fijne\" gebruiker:\n"
+"Deze opmerking is gepost door een twijfelachtige gebruiker:\n"
 "\n"
 "%(text)s"
 
@@ -1449,7 +1449,7 @@
 #: contrib/comments/views/comments.py:208
 #: contrib/comments/views/comments.py:295
 msgid "The comment form had an invalid 'target' parameter -- the object ID was invalid"
-msgstr "Het opmerkingenformulier heeft een ongeldig 'target' parameter -- het object ID was ongeldig"
+msgstr "Het opmerkingenformulier heeft een ongeldig 'target' parameter -- het object-ID was ongeldig"
 
 #: contrib/comments/views/comments.py:259
 #: contrib/comments/views/comments.py:324
@@ -1462,7 +1462,7 @@
 
 #: contrib/comments/views/karma.py:25
 msgid "Invalid comment ID"
-msgstr "Ongeldige opmerkingen ID"
+msgstr "Ongeldige opmerkingen-ID"
 
 #: contrib/comments/views/karma.py:27
 msgid "No voting for yourself"
@@ -1470,7 +1470,7 @@
 
 #: contrib/contenttypes/models.py:37
 msgid "python model class name"
-msgstr "python model-class-naam"
+msgstr "klassenaam van pythonmodel"
 
 #: contrib/contenttypes/models.py:40
 msgid "content type"
@@ -1510,7 +1510,7 @@
 
 #: contrib/flatpages/models.py:14
 msgid "If this is checked, only logged-in users will be able to view the page."
-msgstr "Indien dit is aangekruist kunnen alleen ingelogde gebruikers deze pagina bekijken."
+msgstr "Indien dit is aangekruist kunnen alleen aangemelde gebruikers deze pagina bekijken."
 
 #: contrib/flatpages/models.py:18
 msgid "flat page"
@@ -1547,19 +1547,19 @@
 #, python-format
 msgid "%(value).1f billion"
 msgid_plural "%(value).1f billion"
-msgstr[0] "%(value).1f biljoen"
-msgstr[1] "%(value).1f biljoen"
+msgstr[0] "%(value).1f miljard"
+msgstr[1] "%(value).1f miljard"
 
 #: contrib/humanize/templatetags/humanize.py:57
 #, python-format
 msgid "%(value).1f trillion"
 msgid_plural "%(value).1f trillion"
-msgstr[0] "%(value).1f triljoen"
-msgstr[1] "%(value).1f triljoen"
+msgstr[0] "%(value).1f biljoen"
+msgstr[1] "%(value).1f biljoen"
 
 #: contrib/humanize/templatetags/humanize.py:73
 msgid "one"
-msgstr "een"
+msgstr "één"
 
 #: contrib/humanize/templatetags/humanize.py:73
 msgid "two"
@@ -1607,7 +1607,7 @@
 
 #: contrib/localflavor/ar/forms.py:27
 msgid "Enter a postal code in the format NNNN or ANNNNAAA."
-msgstr ""
+msgstr "Voer een postcode in het formaat NNNN of ANNNNAAA in."
 
 #: contrib/localflavor/ar/forms.py:49
 #: contrib/localflavor/br/forms.py:96
@@ -1615,59 +1615,59 @@
 #: contrib/localflavor/pe/forms.py:23
 #: contrib/localflavor/pe/forms.py:51
 msgid "This field requires only numbers."
-msgstr ""
+msgstr "Dit veld staat alleen getallen toe."
 
 #: contrib/localflavor/ar/forms.py:50
 msgid "This field requires 7 or 8 digits."
-msgstr ""
+msgstr "Dit veld vereist 7 of 8 cijfers."
 
 #: contrib/localflavor/ar/forms.py:79
 msgid "Enter a valid CUIT in XX-XXXXXXXX-X or XXXXXXXXXXXX format."
-msgstr ""
+msgstr "Voer een geldige CUIT in het formaat XX-XXXXXXXX-X of XXXXXXXXXXXX in."
 
 #: contrib/localflavor/ar/forms.py:80
 msgid "Invalid CUIT."
-msgstr ""
+msgstr "Ongeldige CUIT."
 
 #: contrib/localflavor/au/forms.py:16
 msgid "Enter a 4 digit post code."
-msgstr ""
+msgstr "Voer een viercijferige postcode in."
 
 #: contrib/localflavor/br/forms.py:21
 msgid "Enter a zip code in the format XXXXX-XXX."
-msgstr ""
+msgstr "Voer een postcode in het formaat XXXXX-XXX in."
 
 #: contrib/localflavor/br/forms.py:30
 msgid "Phone numbers must be in XX-XXXX-XXXX format."
-msgstr ""
+msgstr "Telefoonummers moeten in het XX-XXXX-XXXX-formaat zijn."
 
 #: contrib/localflavor/br/forms.py:58
 msgid "Select a valid brazilian state. That state is not one of the available states."
-msgstr ""
+msgstr "Selecteer een geldig Braziliaanse staat in. Deze staat is niet geldig."
 
 #: contrib/localflavor/br/forms.py:94
 msgid "Invalid CPF number."
-msgstr ""
+msgstr "Ongeldig CPF-nummer."
 
 #: contrib/localflavor/br/forms.py:95
 msgid "This field requires at most 11 digits or 14 characters."
-msgstr ""
+msgstr "Dit veld accepteert maximaal 11 cijfers of 14 karakters."
 
 #: contrib/localflavor/br/forms.py:134
 msgid "Invalid CNPJ number."
-msgstr ""
+msgstr "Ongeldig CPNJ-nummer."
 
 #: contrib/localflavor/br/forms.py:136
 msgid "This field requires at least 14 digits"
-msgstr ""
+msgstr "Dit veld vereist tenminste 14 cijfers"
 
 #: contrib/localflavor/ca/forms.py:17
 msgid "Enter a postal code in the format XXX XXX."
-msgstr ""
+msgstr "Voer een postcode in het formaat XXX XXX in"
 
 #: contrib/localflavor/ca/forms.py:88
 msgid "Enter a valid Canadian Social Insurance number in XXX-XXX-XXX format."
-msgstr ""
+msgstr "Voer een geldig Canadees 'Social Insurance'-nummer in het formaat XXX-XXX-XXX in."
 
 #: contrib/localflavor/ch/ch_states.py:5
 msgid "Aargau"
@@ -1776,23 +1776,23 @@
 #: contrib/localflavor/ch/forms.py:16
 #: contrib/localflavor/no/forms.py:12
 msgid "Enter a zip code in the format XXXX."
-msgstr ""
+msgstr "Voer een postcode in het formaat XXXX in."
 
 #: contrib/localflavor/ch/forms.py:64
 msgid "Enter a valid Swiss identity or passport card number in X1234567<0 or 1234567890 format."
-msgstr ""
+msgstr "Voer een geldig Zwitserse identiteits- of paspoortkaartnummer in, in het formaat X1234567<0 of 1234567890."
 
 #: contrib/localflavor/cl/forms.py:29
 msgid "Enter a valid Chilean RUT."
-msgstr ""
+msgstr "Voer een geldige Chileense RUT in."
 
 #: contrib/localflavor/cl/forms.py:30
 msgid "Enter a valid Chilean RUT. The format is XX.XXX.XXX-X."
-msgstr ""
+msgstr "Voer een geldige Chileense RUT in. Het formaat is XX.XXX.XXX-X."
 
 #: contrib/localflavor/cl/forms.py:31
 msgid "The Chilean RUT is not valid."
-msgstr ""
+msgstr "De Chileense RUT is ongeldig."
 
 #: contrib/localflavor/de/de_states.py:5
 msgid "Baden-Wuerttemberg"
@@ -1800,11 +1800,11 @@
 
 #: contrib/localflavor/de/de_states.py:6
 msgid "Bavaria"
-msgstr ""
+msgstr "Beieren"
 
 #: contrib/localflavor/de/de_states.py:7
 msgid "Berlin"
-msgstr ""
+msgstr "Berlijn"
 
 #: contrib/localflavor/de/de_states.py:8
 msgid "Brandenburg"
@@ -1828,11 +1828,11 @@
 
 #: contrib/localflavor/de/de_states.py:13
 msgid "Lower Saxony"
-msgstr ""
+msgstr "Neder-Saksen"
 
 #: contrib/localflavor/de/de_states.py:14
 msgid "North Rhine-Westphalia"
-msgstr ""
+msgstr "Noord-Rijnland-Westfalen"
 
 #: contrib/localflavor/de/de_states.py:15
 msgid "Rhineland-Palatinate"
@@ -1844,15 +1844,15 @@
 
 #: contrib/localflavor/de/de_states.py:17
 msgid "Saxony"
-msgstr ""
+msgstr "Saksen"
 
 #: contrib/localflavor/de/de_states.py:18
 msgid "Saxony-Anhalt"
-msgstr ""
+msgstr "Saksen-Anhalt"
 
 #: contrib/localflavor/de/de_states.py:19
 msgid "Schleswig-Holstein"
-msgstr ""
+msgstr "Sleeswijk-Holstein"
 
 #: contrib/localflavor/de/de_states.py:20
 msgid "Thuringia"
@@ -1862,11 +1862,11 @@
 #: contrib/localflavor/fi/forms.py:12
 #: contrib/localflavor/fr/forms.py:15
 msgid "Enter a zip code in the format XXXXX."
-msgstr ""
+msgstr "Voer een postcode in het formaat XXXXX in."
 
 #: contrib/localflavor/de/forms.py:41
 msgid "Enter a valid German identity card number in XXXXXXXXXXX-XXXXXXX-XXXXXXX-X format."
-msgstr ""
+msgstr "Voer een geldig Duits identificatiekaartnummer in het formaat XXXXXXXXXXX-XXXXXXX-XXXXXXX-X in."
 
 #: contrib/localflavor/es/es_provinces.py:5
 msgid "Arava"
@@ -2089,19 +2089,19 @@
 
 #: contrib/localflavor/es/es_regions.py:7
 msgid "Principality of Asturias"
-msgstr ""
+msgstr "Vorstendom van Asturias"
 
 #: contrib/localflavor/es/es_regions.py:8
 msgid "Balearic Islands"
-msgstr ""
+msgstr "Balearische eilanden."
 
 #: contrib/localflavor/es/es_regions.py:9
 msgid "Basque Country"
-msgstr ""
+msgstr "Baskenland"
 
 #: contrib/localflavor/es/es_regions.py:10
 msgid "Canary Islands"
-msgstr ""
+msgstr "Canarische eilanden"
 
 #: contrib/localflavor/es/es_regions.py:12
 msgid "Castile-La Mancha"
@@ -2113,7 +2113,7 @@
 
 #: contrib/localflavor/es/es_regions.py:14
 msgid "Catalonia"
-msgstr ""
+msgstr "Catalonië"
 
 #: contrib/localflavor/es/es_regions.py:15
 msgid "Extremadura"
@@ -3377,7 +3377,7 @@
 
 #: contrib/redirects/models.py:8
 msgid "This should be an absolute path, excluding the domain name. Example: '/events/search/'."
-msgstr "Dit moet een absoluut pad zijn, zonder de domein naam. Bijvoorbeeld: '/events/search/'."
+msgstr "Dit moet een absoluut pad zijn, zonder de domeinnaam. Bijvoorbeeld: '/events/search/'."
 
 #: contrib/redirects/models.py:9
 msgid "redirect to"
@@ -3461,7 +3461,7 @@
 
 #: core/validators.py:111
 msgid "Please enter a valid IP address."
-msgstr "Geef een geldig IP adres op."
+msgstr "Geef een geldig IP-adres op."
 
 #: core/validators.py:115
 msgid "Empty values are not allowed here."
@@ -3517,7 +3517,7 @@
 #: newforms/fields.py:432
 #: oldforms/__init__.py:687
 msgid "No file was submitted. Check the encoding type on the form."
-msgstr "Er was geen bestand verstuurd. Controleer het coderings type van het formulier."
+msgstr "Er is geen bestand verstuurd. Controleer het coderingstype van het formulier."
 
 #: core/validators.py:193
 #: newforms/fields.py:458
@@ -3582,11 +3582,11 @@
 #: core/validators.py:288
 #, python-format
 msgid "This field must match the '%s' field."
-msgstr "Dit veld moet overeenkomen met het '%s' veld."
+msgstr "Dit veld moet overeenkomen met het '%s'-veld."
 
 #: core/validators.py:307
 msgid "Please enter something for at least one field."
-msgstr "Voer tenminste 1 veld in."
+msgstr "Voer tenminste één veld in."
 
 #: core/validators.py:316
 #: core/validators.py:327
@@ -3833,7 +3833,7 @@
 #: newforms/fields.py:295
 #: newforms/fields.py:724
 msgid "Enter a valid time."
-msgstr "Geef een geldige datum op."
+msgstr "Geef een geldige tijd op."
 
 #: newforms/fields.py:334
 msgid "Enter a valid date/time."
@@ -3841,7 +3841,7 @@
 
 #: newforms/fields.py:433
 msgid "No file was submitted."
-msgstr "Geen file werd aangeboden."
+msgstr "Geen bestand werd aangeboden."
 
 #: newforms/fields.py:434
 #: oldforms/__init__.py:689
@@ -3854,7 +3854,7 @@
 
 #: newforms/fields.py:497
 msgid "This URL appears to be a broken link."
-msgstr "Deze URL schijnt niet te werken."
+msgstr "Deze URL lijkt niet te werken."
 
 #: newforms/fields.py:559
 #: newforms/models.py:300
@@ -3874,7 +3874,7 @@
 
 #: newforms/fields.py:752
 msgid "Enter a valid IPv4 address."
-msgstr "Geef een geldig IPv4 adres op."
+msgstr "Geef een geldig IPv4-adres op."
 
 #: newforms/models.py:361
 #, python-format
@@ -4080,7 +4080,7 @@
 
 #: utils/dates.py:23
 msgid "mar"
-msgstr "mar"
+msgstr "mrt"
 
 #: utils/dates.py:23
 msgid "apr"